// SweeperPlayerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SweeperPlayer.h"
#include "SweeperPlayerDlg.h"
#include ".\sweeperplayerdlg.h"

#include <vector>
#include <string>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



RECT wndRect;
// CSweeperPlayerDlg dialog



CSweeperPlayerDlg::CSweeperPlayerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSweeperPlayerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSweeperPlayerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSweeperPlayerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()


// CSweeperPlayerDlg message handlers

BOOL CSweeperPlayerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSweeperPlayerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSweeperPlayerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


vector<HWND> list;
BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
	list.push_back(hwnd);
	return TRUE;
}



int CSweeperPlayerDlg::GetTile(int x, int y)
{
	COLORREF colors[9] = {0xFFFFFF, 0xFF0000, 0x008000, 0x0000FF, 0x800000, 0x000080, 0x808000, 0x000000, 0x808080};
	x *= 16;
	y *= 16;
	x += mx + 1;
	y += my + 1;
	for(int xt = x; xt < x + 11; xt++)
	{
		for(int yt = y; yt < y + 11; yt++)
		{
			COLORREF color = buffDC.GetPixel(xt, yt);
			for(int c = 0; c < 9; c++)
			{
				if(colors[c] == color) 
				{
					return c;
				}
			}
		}
	}

	return -1;
}

// Fills the map structure from the specified window
void CSweeperPlayerDlg::GetMap(HWND hwnd)
{
	HDC mineHDC = ::GetWindowDC(hwnd);
	CDC *mineDC = CDC::FromHandle(mineHDC);


	buffDC.CreateCompatibleDC(mineDC);
	buffDC.SelectObject(&bmp);

	
	buffDC.BitBlt(0, 0, MINE_WIDTH, MINE_HEIGHT, mineDC, 0, 0, SRCCOPY);
	::ReleaseDC(hwnd, mineHDC);

	mx = -1;
	my = -1;



	for(int y = 0; y < 200; y++)
	{
		for(int x = 0; x < 200; x++)
		{
			COLORREF r = buffDC.GetPixel(x, y);
			if(buffDC.GetPixel(x, y) == 0x000000FF)
			{
				mx = x;
				my = y;
				break;
			}
		}
		if(mx != -1) break;
	}


	mx -= 7;
	my += 38;

	CDC *myDC = GetDC();
	myDC->BitBlt(0, 0, MINE_WIDTH, MINE_HEIGHT, &buffDC, 0, 0, SRCCOPY);

	
	
	ReleaseDC(myDC);

	for(int xt = 0; xt < sizex; xt++)
	{
		for(int yt = 0; yt < sizey; yt++)
		{
			map[xt][yt] = GetTile(xt, yt);
		}

	}
	

	
	buffDC.DeleteDC();
}


// Returns the HWND of the first window found with the title of "Minesweeper"
HWND CSweeperPlayerDlg::FindMineWindow()
{

	list.clear();

	// Fill the list with all currently open windows
	EnumWindows(EnumWindowsProc, 0);
	

	// We want to find the window with the "Minesweeper" title
	char buf[256];
	string title, mine;
	mine = "Minesweeper";
	for(int i = 0; i < list.size(); i++)
	{
		::GetWindowText(list[i], buf, sizeof(buf) - 1);
		title = buf;
		if(title == mine)
			return list[i];
	}

	// -1 on failure
	return (HWND)-1;

}

int CSweeperPlayerDlg::GetMapTile(int x, int y)
{
	if(x < 0) return -1;
	if(y < 0) return -1;
	if(x >= sizex) return -1;
	if(y >= sizey) return -1;
	return map[x][y];
}

int CSweeperPlayerDlg::GetMineTile(int x, int y)
{
	if(x < 0) return -1;
	if(y < 0) return -1;
	if(x >= sizex) return -1;
	if(y >= sizey) return -1;
	return mineMap[x][y];
}

void CSweeperPlayerDlg::SetClearMap(int x, int y)
{
	if(x >= 0 && x < sizex && y >= 0 && y < sizey)
		clearMap[x][y] = 1;
}

// Returns the number of unclicked tiles that have no mark on them
int CSweeperPlayerDlg::CountUnknown(int x, int y)
{
	int count = 0;
	if(GetMapTile(x - 1, y - 1) == 0) count ++;
	if(GetMapTile(x , y - 1) == 0) count ++;
	if(GetMapTile(x + 1, y - 1) == 0) count ++;
	if(GetMapTile(x - 1, y ) == 0) count ++;
	if(GetMapTile(x + 1, y ) == 0) count ++;
	if(GetMapTile(x - 1, y + 1) == 0) count ++;
	if(GetMapTile(x, y + 1) == 0) count ++;
	if(GetMapTile(x + 1, y + 1) == 0) count ++;
	return count;
}

// Returns the number of known mines adjacent
int CSweeperPlayerDlg::CountMines(int x, int y)
{
	int count = 0;
	if(GetMineTile(x - 1, y - 1) == 1) count ++;
	if(GetMineTile(x , y - 1) == 1) count ++;
	if(GetMineTile(x + 1, y - 1) == 1) count ++;
	if(GetMineTile(x - 1, y ) == 1) count ++;
	if(GetMineTile(x + 1, y ) == 1) count ++;
	if(GetMineTile(x - 1, y + 1) == 1) count ++;
	if(GetMineTile(x, y + 1) == 1) count ++;
	if(GetMineTile(x + 1, y + 1) == 1) count ++;
	return count;
}

void CSweeperPlayerDlg::MarkMines()
{
	for(int x = 0; x < sizex; x++)
	{
		for(int y = 0; y < sizey; y++)
		{
			if(map[x][y] > 0)
			{
				if(CountUnknown(x, y) == map[x][y])
				{
					if(GetMapTile(x - 1, y - 1) == 0) mineMap[x - 1][y - 1] = 1;
					if(GetMapTile(x, y - 1) == 0) mineMap[x][y - 1] = 1;
					if(GetMapTile(x + 1, y - 1) == 0) mineMap[x + 1][y - 1] = 1;
					if(GetMapTile(x - 1, y) == 0) mineMap[x - 1][y] = 1;
					if(GetMapTile(x + 1, y) == 0) mineMap[x + 1][y] = 1;
					if(GetMapTile(x - 1, y + 1) == 0) mineMap[x - 1][y + 1] = 1;
					if(GetMapTile(x, y + 1) == 0) mineMap[x][y + 1] = 1;
					if(GetMapTile(x + 1, y + 1) == 0) mineMap[x + 1][y + 1] = 1;
				}
			}
		}
	}
}

void CSweeperPlayerDlg::MarkClear()
{
	for(int x = 0; x < sizex; x++)
	{
		for(int y = 0; y < sizey; y++)
		{
			if(map[x][y] > 0)
			{
				if(CountMines(x, y) == map[x][y])
				{
					if(GetMineTile(x - 1, y - 1) == 0) clearMap[x - 1][y - 1] = 1;
					if(GetMineTile(x, y - 1) == 0) clearMap[x][y - 1] = 1;
					if(GetMineTile(x + 1, y - 1) == 0) clearMap[x + 1][y - 1] = 1;
					if(GetMineTile(x - 1, y) == 0) clearMap[x - 1][y] = 1;
					if(GetMineTile(x + 1, y) == 0) clearMap[x + 1][y] = 1;
					if(GetMineTile(x - 1, y + 1) == 0) clearMap[x - 1][y + 1] = 1;
					if(GetMineTile(x, y + 1) == 0) clearMap[x][y + 1] = 1;
					if(GetMineTile(x + 1, y + 1) == 0) clearMap[x + 1][y + 1] = 1;
				}
			}
		}
	}
}

bool CSweeperPlayerDlg::ClickClear(HWND mineWnd)
{
	//HWND desktop = ::GetDesktopWindow();
	//RECT deskRect;
	//::GetWindowRect(desktop, &deskRect);

	bool clicked = false;
	for(int x = 0; x < sizex; x++)
	{
		for(int y = 0; y < sizey; y++)
		{
			//if((clearMap[x][y] == 1) && (clickMap[x][y] == 0))
			if(clearMap[x][y] == 1)
			{
				//clickMap[x][y] = 1;
				if(map[x][y] == 0)
				{

					clicked = true;
					ClickTile(x, y, mineWnd);
					/*
					long xs = (wndRect.left + mx + x * 16 + 8) * 65535 / deskRect.right;
					long ys = (wndRect.top + my + y * 16 + 8) * 65535 / deskRect.bottom;
					mouse_event(MOUSEEVENTF_ABSOLUTE | MOUSEEVENTF_MOVE, xs, ys, 0, 0);
					Sleep(1);
					mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
					Sleep(1);
					mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
					Sleep(1);
					*/
				}
			}
		}
	}


	return clicked;
}

void CSweeperPlayerDlg::ClickTile(int x, int y, HWND mineWnd)
{
	RECT wndRect, clientRect;
	::GetWindowRect(mineWnd, &wndRect);
	::GetWindowRect(mineWnd, &clientRect);
	::AdjustWindowRect(&clientRect, (DWORD)GetWindowLong(mineWnd, GWL_STYLE), true);

	LPARAM pos;
	int xs = mx + x * 16 + 8 - (wndRect.left - clientRect.left);
	int ys = my + y * 16 + 8 - (wndRect.top - clientRect.top);
	pos = xs | (ys << 16);

	::SendMessage(mineWnd, WM_LBUTTONDOWN, 0, pos);
	::SendMessage(mineWnd, WM_LBUTTONUP, 0, pos);

}

void CSweeperPlayerDlg::ClickRandom(HWND mineWnd)
{
	
	int x = rand() % sizex;
	int y = rand() % sizey;

	if(0 == mineMap[x][y]) ClickTile(x, y, mineWnd);
}

bool CSweeperPlayerDlg::CheckLost()
{
	return false;
}

bool CSweeperPlayerDlg::CheckWon()
{
	return false;
}

void CSweeperPlayerDlg::OnBnClickedOk()
{

	for(int x = 0; x < sizex; x++)
	{
		for(int y = 0; y < sizey; y++)
		{
			map[x][y] = 0;
			mineMap[x][y] = 0;
			clearMap[x][y] = 0;
			clickMap[x][y] = 0;
		}
	}

	

	// Get the minesweeper window
	HWND mineWnd = FindMineWindow();
	// Check if the window exists
	if(mineWnd == (HWND)-1) return;
	
	// Create our buffer
	{
		HDC mineHDC = ::GetWindowDC(mineWnd);
		// We can't use the FromHandle object for long
		CDC *mineDC = CDC::FromHandle(mineHDC);
		bmp.CreateCompatibleBitmap(mineDC, MINE_WIDTH, MINE_HEIGHT);
	}

	::GetWindowRect(mineWnd, &wndRect);


	while(1)
	{

		GetMap(mineWnd);

		for(int x = 0; x < sizex; x++)
		{
			for(int y = 0; y < sizey; y++)
			{
				mineMap[x][y] = 0;
				clearMap[x][y] = 0;
			}
		}
		MarkMines();
		MarkClear();
		

		if(!ClickClear(mineWnd))
		{
			ClickRandom(mineWnd);
		}

		if(CheckLost())
		{

		}

		if(CheckWon())
		{

		}

		Sleep(0);

		
	}

	
}



void CSweeperPlayerDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	CDialog::OnLButtonDown(nFlags, point);
}
